(function (global, factory) {
	if (typeof define === "function" && define.amd) {
		define(["exports", "react", "react-dom", "velocity-react", "velocity-animate", "lodash"], factory);
	} else if (typeof exports !== "undefined") {
		factory(exports, require("react"), require("react-dom"), require("velocity-react"), require("velocity-animate"), require("lodash"));
	} else {
		var mod = {
			exports: {}
		};
		factory(mod.exports, global.react, global.reactDom, global.velocityReact, global.velocityAnimate, global.lodash);
		global.index = mod.exports;
	}
})(this, function (exports, _react, _reactDom, _velocityReact, _velocityAnimate, _lodash) {
	"use strict";

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _react2 = _interopRequireDefault(_react);

	var _reactDom2 = _interopRequireDefault(_reactDom);

	var _lodash2 = _interopRequireDefault(_lodash);

	function _interopRequireDefault(obj) {
		return obj && obj.__esModule ? obj : {
			default: obj
		};
	}

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
		return typeof obj;
	} : function (obj) {
		return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
	};

	function _classCallCheck(instance, Constructor) {
		if (!(instance instanceof Constructor)) {
			throw new TypeError("Cannot call a class as a function");
		}
	}

	var _createClass = function () {
		function defineProperties(target, props) {
			for (var i = 0; i < props.length; i++) {
				var descriptor = props[i];
				descriptor.enumerable = descriptor.enumerable || false;
				descriptor.configurable = true;
				if ("value" in descriptor) descriptor.writable = true;
				Object.defineProperty(target, descriptor.key, descriptor);
			}
		}

		return function (Constructor, protoProps, staticProps) {
			if (protoProps) defineProperties(Constructor.prototype, protoProps);
			if (staticProps) defineProperties(Constructor, staticProps);
			return Constructor;
		};
	}();

	function _possibleConstructorReturn(self, call) {
		if (!self) {
			throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
		}

		return call && (typeof call === "object" || typeof call === "function") ? call : self;
	}

	function _inherits(subClass, superClass) {
		if (typeof superClass !== "function" && superClass !== null) {
			throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
		}

		subClass.prototype = Object.create(superClass && superClass.prototype, {
			constructor: {
				value: subClass,
				enumerable: false,
				writable: true,
				configurable: true
			}
		});
		if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	}

	//
	//*************************
	//*************************
	// Nonpublished Imports
	//
	function updateState(ScopeProxy, Parcel) {
		var existingState = ScopeProxy.state !== null ? _lodash2.default.cloneDeep(ScopeProxy.state) : {};
		var adjustedState = _lodash2.default.merge(existingState, _lodash2.default.cloneDeep(Parcel));
		//
		try {
			ScopeProxy.setState(adjustedState);
		} catch (event) {
			console.warn("::react-kinetictext:problem::updateState:", event);
		}
	}
	function watch(Testfunction) {
		var watchCore = {
			"Match": function Match(Target, Complete, ExpireAt) {
				var intervalCount = 0;
				var maximumAttempts = ExpireAt !== undefined ? ExpireAt : 2000;
				//
				var watchInterval = setInterval(function () {
					if (Testfunction() === Target) {
						Complete();
						//
						clearInterval(watchInterval);
					}
					if (intervalCount >= maximumAttempts) {
						console.warn("react-kinetictext.js::watch::exceeded watch limit timeout::action halted.");
						//
						clearInterval(watchInterval);
					}
					intervalCount++;
				}, 1);
				//
			}
		};
		//
		return watchCore;
	}
	//
	//*************************
	//*************************
	// Exports
	//

	var Kinetictext = function (_Component) {
		_inherits(Kinetictext, _Component);

		//*************************
		//*************************
		// Standard Methods
		//
		function Kinetictext(props) {
			_classCallCheck(this, Kinetictext);

			return _possibleConstructorReturn(this, (Kinetictext.__proto__ || Object.getPrototypeOf(Kinetictext)).call(this, props));
		}

		_createClass(Kinetictext, [{
			key: "getChildContext",
			value: function getChildContext() {
				// empty
			}
		}, {
			key: "getInitialState",
			value: function getInitialState() {
				return {};
			}
		}, {
			key: "componentWillMount",
			value: function componentWillMount() {
				var scopeProxy = this;
				//
				scopeProxy.kinetictextProfile = {
					"Ready": false,
					"Panel": {
						"Classname": scopeProxy.props.Panel.Classname
					},
					"Sample": {
						"Child": scopeProxy.props.children,
						"Style": scopeProxy.props.Morph.Style,
						"Ready": scopeProxy.props.Ready,
						"Process": false
					},
					"Morph": {
						"Index": 0,
						"Profile": scopeProxy.props.Morph.Profile,
						"Portal": scopeProxy.props.Morph.Portal,
						"Path": scopeProxy.props.Morph.Path.d,
						"Change": scopeProxy.props.Morph.Change,
						"Complete": scopeProxy.props.Morph.Complete,
						"Profiles": []
					}
				};
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				// empty
			}
		}, {
			key: "componentDidMount",
			value: function componentDidMount() {
				var scopeProxy = this;
				//
				scopeProxy.kinetictextProfile.Sample.Ready(scopeProxy.kinetictextProfile.Sample.Child.props.children);
			}
		}, {
			key: "componentWillUpdate",
			value: function componentWillUpdate() {
				// empty
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate() {
				var scopeProxy = this;
				//
				window.requestAnimationFrame(function () {
					if (scopeProxy.kinetictextProfile !== undefined && scopeProxy.kinetictextProfile.Ready === false) {
						scopeProxy.kinetictextProfile.Ready = true;
						//
						scopeProxy.kinetictextProfile.Sample.Ready(scopeProxy.kinetictextProfile.Sample.Child.props.children);
					}
				});
			}
		}, {
			key: "render",
			value: function render() {
				var scopeProxy = this;
				var childElementCount = 0;
				var morphElementCount = 0;
				var kinetictextId = scopeProxy.props.id;
				var processSample = _lodash2.default.has(scopeProxy, "state.Sample.Process") ? scopeProxy.state.Sample.Process : false;
				var kinetictextpanelClassname = _lodash2.default.has(scopeProxy, "kinetictextProfile.Panel.Classname") ? scopeProxy.kinetictextProfile.Panel.Classname : null;
				var kinetictextsampleStyle = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style") ? scopeProxy.kinetictextProfile.Sample.Style : null;
				var sampleChild = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Child") ? scopeProxy.kinetictextProfile.Sample.Child.props.children.split("") : [];
				var samplePerspective = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Portal.Perspective") ? scopeProxy.kinetictextProfile.Morph.Portal.Perspective : "0px";
				var childElements = null;
				//
				var portalmorphProfileOnmount = {
					"runOnMount": false
				};
				//
				if (processSample === true) {
					childElements = sampleChild.map(function (childElement) {
						var morphElement = null;
						var morphelementId = kinetictextId.concat("_morph-element_", childElementCount.toString(), "-container");
						var morphelementhostId = kinetictextId.concat("_morph-elementhost_", childElementCount.toString(), "-container");
						var morphPath = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Path") ? scopeProxy.kinetictextProfile.Morph.Path : null;
						var adjustedMorphPath = (typeof morphPath === "undefined" ? "undefined" : _typeof(morphPath)) === "object" && morphPath !== null ? morphPath[childElementCount] : morphPath;
						var pathId = kinetictextId.concat("_child-path_", childElementCount.toString(), "-svg");
						var morphProfile = _lodash2.default.has(scopeProxy, "state.Morph.Profiles") ? scopeProxy.state.Morph.Profiles[childElementCount] : null;
						var velocitychildElementId = kinetictextId.concat("_velocity-element-", childElement);
						//
						var pathStyle = {
							"fill": "none",
							"fill-rule": "evenodd",
							"stroke-width": "1px",
							"stroke": "rgba(0,0,0,1)",
							"stroke-linecap": "butt",
							"stroke-linejoin": "miter",
							"stroke-opacity": 1
						};
						//
						var morphelementStyle = {
							"display": "inline-block",
							"position": "relative"
						};
						//
						var morphelementhostStyle = {
							"display": "inline-block",
							"position": "relative",
							"transform-style": "preserve-3d",
							"perspective": samplePerspective
						};
						//
						var velocitychildStyle = {
							"opacity": "0"
						};
						//


						if (childElement !== " ") {
							morphElement = _react2.default.createElement(
								"div",
								{ id: morphelementhostId, style: morphelementhostStyle },
								_react2.default.createElement(
									"div",
									{ id: morphelementId, style: morphelementStyle },
									childElement
								),
								_react2.default.createElement(
									"svg",
									{ width: "0px", height: "0px" },
									_react2.default.createElement(
										"g",
										{ id: "path-layer" },
										_react2.default.createElement("path", { id: pathId, style: pathStyle, d: adjustedMorphPath })
									)
								),
								_react2.default.createElement(
									_velocityReact.VelocityComponent,
									morphProfile,
									_react2.default.createElement("div", { id: velocitychildElementId, style: velocitychildStyle })
								)
							);
						} else {
							morphElement = _react2.default.createElement(
								"div",
								{ id: morphelementhostId, style: morphelementhostStyle },
								_react2.default.createElement(
									"div",
									{ id: morphelementId, style: morphelementStyle },
									"\xA0"
								),
								_react2.default.createElement(
									"svg",
									{ width: "0px", height: "0px" },
									_react2.default.createElement(
										"g",
										{ id: "path-layer" },
										_react2.default.createElement("path", { id: pathId, style: pathStyle, d: adjustedMorphPath })
									)
								),
								_react2.default.createElement(
									_velocityReact.VelocityComponent,
									morphProfile,
									_react2.default.createElement("div", { id: velocitychildElementId, style: velocitychildStyle })
								)
							);
						}
						childElementCount++;
						//
						return morphElement;
					});
				} else {
					childElements = this.props.children;
				}
				return _react2.default.createElement(
					"div",
					{ id: "kinetictext-panel-container", className: kinetictextpanelClassname },
					_react2.default.createElement(
						"div",
						{ id: "kinetictext-sample-container", className: scopeProxy.props.children.props.className },
						childElements
					)
				);
			}
		}, {
			key: "setListeners",
			value: function setListeners() {
				var scopeProxy = this;
				//
			}
		}, {
			key: "animateSample",
			value: function animateSample() {
				var scopeProxy = this;
				var kinetictextId = scopeProxy.props.id;
				var sampleChild = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Child") ? scopeProxy.kinetictextProfile.Sample.Child.props.children.split("") : [];
				var sampleLength = sampleChild.length;
				var velocitychildElementId = kinetictextId.concat("_velocity-element-", sampleChild[sampleLength - 1]);
				var processSample = _lodash2.default.has(scopeProxy, "state.Sample.Process") ? scopeProxy.state.Sample.Process : false;
				//
				if (processSample === false) {
					updateState(scopeProxy, {
						"Sample": {
							"Process": true
						}
					});
					watch(function () {
						var beginAnimate = scopeProxy.state.Sample.Process;
						//
						return beginAnimate;
					}).Match(true, function (event) {
						scopeProxy.resetProfiles();
					});
				}
				watch(function () {
					var velocitychildElement = document.getElementById(velocitychildElementId);
					var lastelementOpacity = velocitychildElement !== null ? parseInt(velocitychildElement.style.opacity) : null;
					//
					return lastelementOpacity;
				}).Match(0, function (event) {
					window.requestAnimationFrame(function () {
						scopeProxy.morphSample();
					});
				});
			}
		}, {
			key: "morphSample",
			value: function morphSample() {
				var scopeProxy = this;
				var kinetictextId = scopeProxy.props.id;
				var sampleChild = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Child") ? scopeProxy.kinetictextProfile.Sample.Child.props.children.split("") : [];
				var morphIndex = _lodash2.default.has(scopeProxy, "state.Morph.Index") ? scopeProxy.state.Morph.Index : 0;
				var sampleLength = sampleChild.length;
				var childTranslateZ = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.TranslateZ") ? scopeProxy.kinetictextProfile.Sample.Style.TranslateZ : null;
				var childOpacity = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Opacity") ? scopeProxy.kinetictextProfile.Sample.Style.Opacity : null;
				var childBlur = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Blur") ? scopeProxy.kinetictextProfile.Sample.Style.Blur : null;
				var childRotation = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Rotation") ? scopeProxy.kinetictextProfile.Sample.Style.Rotation : null;
				var childScaleX = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.ScaleX") ? scopeProxy.kinetictextProfile.Sample.Style.ScaleX : null;
				var childScaleY = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.ScaleY") ? scopeProxy.kinetictextProfile.Sample.Style.ScaleY : null;
				var morphDuration = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Profile.Duration") ? scopeProxy.kinetictextProfile.Morph.Profile.Duration : null;
				var morphEasing = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Profile.Easing") ? scopeProxy.kinetictextProfile.Morph.Profile.Easing : "linear";
				var morphDelay = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Profile.Delay") ? scopeProxy.kinetictextProfile.Morph.Profile.Delay : 0;
				var morphSpaces = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Profile.Spaces") ? scopeProxy.kinetictextProfile.Morph.Profile.Spaces : true;
				var isSequential = _lodash2.default.has(scopeProxy, "kinetictextProfile.Morph.Profile.Sequential") ? scopeProxy.kinetictextProfile.Morph.Profile.Sequential : true;
				var elementProfile = {};
				var elementCount = 0;
				var completeCount = 0;
				//
				var sampleProfiles = sampleChild.map(function (childElement) {
					var pathId = kinetictextId.concat("_child-path_", elementCount.toString(), "-svg");
					var elementId = kinetictextId.concat("_morph-element_", elementCount.toString(), "-container");
					var elementhostId = kinetictextId.concat("_morph-elementhost_", elementCount.toString(), "-container");
					var pathElement = document.getElementById(kinetictextId.concat("_child-path_", elementCount.toString(), "-svg"));
					var pathLength = pathElement !== null ? pathElement.getTotalLength() : 0;
					var adjustedMorphEasing = (typeof morphEasing === "undefined" ? "undefined" : _typeof(morphEasing)) === "object" ? morphEasing[elementCount] : morphEasing;
					var adjustedMorphDuration = (typeof morphDuration === "undefined" ? "undefined" : _typeof(morphDuration)) === "object" ? morphDuration[elementCount] : typeof morphDelay === "function" ? morphDuration() : morphDuration;
					var adjustedMorphDelay = (typeof morphDelay === "undefined" ? "undefined" : _typeof(morphDelay)) === "object" ? morphDelay[elementCount] : typeof morphDelay === "function" ? morphDelay() : morphDelay;
					//
					adjustedMorphDuration = morphSpaces === false && childElement === " " ? 0 : adjustedMorphDuration;
					adjustedMorphDelay = morphSpaces === false && childElement === " " ? 0 : adjustedMorphDelay;
					//
					if (isSequential === true) {
						if (elementCount === morphIndex) {
							elementProfile = {
								"duration": adjustedMorphDuration,
								"easing": adjustedMorphEasing,
								"runOnMount": true,
								"delay": adjustedMorphDelay,
								"animation": {
									"opacity": 1
								},
								"progress": function progress(elements, complete, remaining, start, tweenValue) {
									var progressValue = elements[0].style.opacity;
									var progressLocation = parseFloat(progressValue) * parseFloat(pathLength);
									var pointElement = pathElement !== null ? pathElement.getPointAtLength(progressLocation) : {};
									var locationX = pointElement.x !== undefined ? pointElement.x.toString().concat("px") : "0px";
									var locationY = pointElement.y !== undefined ? pointElement.y.toString().concat("px") : "0px";
									var translateZ = childTranslateZ !== null ? (parseInt(childTranslateZ) * (1 - progressValue)).toString().concat("px") : null;
									var elementOpacity = (1 - parseFloat(childOpacity)) * progressValue + parseFloat(childOpacity);
									var elementBlur = "blur(".concat((parseFloat(childBlur) * (1 - progressValue)).toString(), "px)");
									var elementRotation = ((1 - progressValue) * parseFloat(childRotation)).toString().concat("deg");
									var elementScaleX = parseFloat(childScaleX > 1) ? (parseFloat(childScaleX) - 1) * (1 - progressValue) + 1 : (1 - parseFloat(childScaleX)) * progressValue + parseFloat(childScaleX);
									var elementScaleY = parseFloat(childScaleY > 1) ? (parseFloat(childScaleY) - 1) * (1 - progressValue) + 1 : (1 - parseFloat(childScaleY)) * progressValue + parseFloat(childScaleY);
									var elementTransform = childTranslateZ === null ? "scaleX(".concat(elementScaleX, ") scaleY(", elementScaleY, ") rotate(", elementRotation, ")") : "translateZ(".concat(translateZ, ") rotate(", elementRotation, ")");
									var elementhostTransform = "translateX(".concat(locationX, ") translateY(", locationY, ")");
									var morphElement = document.getElementById(elementId);
									var morphElementhost = document.getElementById(elementhostId);
									//
									Object.assign(morphElement.style, {
										"opacity": elementOpacity,
										"filter": elementBlur,
										"transform": elementTransform
									});
									Object.assign(morphElementhost.style, {
										"transform": elementhostTransform
									});
									scopeProxy.kinetictextProfile.Morph.Change({
										"Host": morphElementhost,
										"Child": childElement
									});
								},
								"complete": function complete(event) {
									var morphElementhost = document.getElementById(elementhostId);
									//
									scopeProxy.kinetictextProfile.Morph.Complete({
										"Host": morphElementhost,
										"Child": childElement
									});
									scopeProxy.morphSample();
								}
							};
						} else {
							elementProfile = {};
						}
					} else {
						elementProfile = {
							"duration": adjustedMorphDuration,
							"easing": adjustedMorphEasing,
							"runOnMount": true,
							"delay": adjustedMorphDelay,
							"animation": {
								"opacity": 1
							},
							"progress": function progress(elements, complete, remaining, start, tweenValue) {
								var progressValue = elements[0].style.opacity;
								var progressLocation = parseFloat(progressValue) * parseFloat(pathLength);
								var pointElement = pathElement !== null ? pathElement.getPointAtLength(progressLocation) : {};
								var locationX = pointElement.x !== undefined ? pointElement.x.toString().concat("px") : "0px";
								var locationY = pointElement.y !== undefined ? pointElement.y.toString().concat("px") : "0px";
								var translateZ = childTranslateZ !== null ? (parseInt(childTranslateZ) * (1 - progressValue)).toString().concat("px") : null;
								var elementOpacity = (1 - parseFloat(childOpacity)) * progressValue + parseFloat(childOpacity);
								var elementBlur = "blur(".concat((parseFloat(childBlur) * (1 - progressValue)).toString(), "px)");
								var elementRotation = ((1 - progressValue) * parseFloat(childRotation)).toString().concat("deg");
								var elementScaleX = parseFloat(childScaleX > 1) ? (parseFloat(childScaleX) - 1) * (1 - progressValue) + 1 : (1 - parseFloat(childScaleX)) * progressValue + parseFloat(childScaleX);
								var elementScaleY = parseFloat(childScaleY > 1) ? (parseFloat(childScaleY) - 1) * (1 - progressValue) + 1 : (1 - parseFloat(childScaleY)) * progressValue + parseFloat(childScaleY);
								var elementTransform = childTranslateZ === null ? "scaleX(".concat(elementScaleX, ") scaleY(", elementScaleY, ") rotate(", elementRotation, ")") : "translateZ(".concat(translateZ, ") rotate(", elementRotation, ")");
								var elementhostTransform = "translateX(".concat(locationX, ") translateY(", locationY, ")");
								var morphElement = document.getElementById(elementId);
								var morphElementhost = document.getElementById(elementhostId);
								//
								Object.assign(morphElement.style, {
									"opacity": elementOpacity,
									"filter": elementBlur,
									"transform": elementTransform
								});
								Object.assign(morphElementhost.style, {
									"transform": elementhostTransform
								});
								scopeProxy.kinetictextProfile.Morph.Change({
									"Host": morphElementhost,
									"Child": childElement
								});
							},
							"complete": function complete(event) {
								var morphElementhost = document.getElementById(elementhostId);
								//
								scopeProxy.kinetictextProfile.Morph.Complete({
									"Host": morphElementhost,
									"Child": childElement
								});
								completeCount++;
								//
								if (completeCount === sampleLength) {
									var _elementCount = 0;
									var _elementhostId = kinetictextId.concat("_morph-elementhost_", _elementCount.toString(), "-container");
									//
									morphElementhost = document.getElementById(_elementhostId);
									//
									Object.assign(morphElementhost.style, {
										"transform": null
									});
									updateState(scopeProxy, {
										"Sample": {
											"Process": false
										}
									});
								}
							}
						};
					}
					elementCount++;
					//
					return elementProfile;
				});
				//
				if (morphIndex <= sampleLength - 1) {
					morphIndex++;
					//
					updateState(scopeProxy, {
						"Morph": {
							"Index": morphIndex,
							"Profiles": sampleProfiles
						}
					});
				} else {
					var _elementCount2 = 0;
					var elementhostId = kinetictextId.concat("_morph-elementhost_", _elementCount2.toString(), "-container");
					var morphElementhost = document.getElementById(elementhostId);
					//
					updateState(scopeProxy, {
						"Sample": {
							"Process": false
						}
					});
					Object.assign(morphElementhost.style, {
						"transform": null
					});
				}
			}
		}, {
			key: "resetProfiles",
			value: function resetProfiles() {
				var scopeProxy = this;
				var kinetictextId = scopeProxy.props.id;
				var sampleChild = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Child") ? scopeProxy.kinetictextProfile.Sample.Child.props.children.split("") : [];
				var sampleLength = sampleChild.length;
				var childelementCount = 0;
				//
				var sampleProfiles = sampleChild.map(function (childElement) {
					var elementProfile = {
						"duration": 0,
						"easing": "easeOutQuad",
						"runOnMount": true,
						"delay": 0,
						"animation": {
							"opacity": 0
						},
						"progress": function progress(elements, complete, remaining, start, tweenValue) {
							// empty
						},
						"complete": function complete(event) {
							// empty
						}
					};
					//
					childelementCount++;
					//
					return elementProfile;
				});
				//
				updateState(scopeProxy, {
					"Morph": {
						"Index": 0,
						"Profiles": sampleProfiles
					}
				});
			}
		}, {
			key: "stageSample",
			value: function stageSample() {
				var scopeProxy = this;
				var processSample = _lodash2.default.has(scopeProxy, "state.Sample.Process") ? scopeProxy.state.Sample.Process : false;
				//
				if (processSample === false) {
					updateState(scopeProxy, {
						"Sample": {
							"Process": true
						}
					});
					watch(function () {
						var beginAnimate = scopeProxy.state.Sample.Process;
						//
						return beginAnimate;
					}).Match(true, function (event) {
						scopeProxy.prepareSample();
						scopeProxy.resetProfiles();
					});
				} else {
					scopeProxy.prepareSample();
				}
			}
		}, {
			key: "prepareSample",
			value: function prepareSample() {
				var scopeProxy = this;
				var kinetictextId = scopeProxy.props.id;
				var processSample = _lodash2.default.has(scopeProxy, "state.Sample.Process") ? scopeProxy.state.Sample.Process : null;
				var sampleChild = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Child") ? scopeProxy.kinetictextProfile.Sample.Child.props.children.split("") : [];
				var sampleLength = sampleChild.length;
				var childTranslateZ = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style") ? scopeProxy.kinetictextProfile.Sample.Style.TranslateZ : null;
				var childOpacity = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Opacity") ? scopeProxy.kinetictextProfile.Sample.Style.Opacity : null;
				var childBlur = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Blur") ? scopeProxy.kinetictextProfile.Sample.Style.Blur : null;
				var childRotation = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.Rotation") ? scopeProxy.kinetictextProfile.Sample.Style.Rotation : null;
				var childScaleX = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.ScaleX") ? scopeProxy.kinetictextProfile.Sample.Style.ScaleX : null;
				var childScaleY = _lodash2.default.has(scopeProxy, "kinetictextProfile.Sample.Style.ScaleY") ? scopeProxy.kinetictextProfile.Sample.Style.ScaleY : null;
				var elementCount = 0;
				//
				var sampleProfiles = sampleChild.map(function (childElement) {
					var pathId = kinetictextId.concat("_child-path_", elementCount.toString(), "-svg");
					var elementId = kinetictextId.concat("_morph-element_", elementCount.toString(), "-container");
					var elementhostId = kinetictextId.concat("_morph-elementhost_", elementCount.toString(), "-container");
					var pathElement = document.getElementById(kinetictextId.concat("_child-path_", elementCount.toString(), "-svg"));
					var pathLength = pathElement !== null ? pathElement.getTotalLength() : 0;
					var progressLocation = 0;
					var pointElement = pathElement !== null ? pathElement.getPointAtLength(progressLocation) : {};
					var locationX = pointElement.x !== undefined ? pointElement.x.toString().concat("px") : "0px";
					var locationY = pointElement.y !== undefined ? pointElement.y.toString().concat("px") : "0px";
					var translateZ = childTranslateZ !== null ? parseInt(childTranslateZ).toString().concat("px") : null;
					var elementOpacity = parseFloat(childOpacity);
					var elementBlur = "blur(".concat(parseFloat(childBlur).toString(), "px)");
					var elementRotation = parseFloat(childRotation).toString().concat("deg");
					var elementScaleX = parseFloat(childScaleX > 1) ? parseFloat(childScaleX) - 1 + 1 : parseFloat(childScaleX);
					var elementScaleY = parseFloat(childScaleY > 1) ? parseFloat(childScaleY) - 1 + 1 : parseFloat(childScaleY);
					var elementTransform = childTranslateZ === null ? "scaleX(".concat(elementScaleX, ") scaleY(", elementScaleY, ") rotate(", elementRotation, ")") : "translateZ(".concat(translateZ, ") rotate(", elementRotation, ")");
					var elementhostTransform = "translateX(".concat(locationX, ") translateY(", locationY, ")");
					var morphElement = document.getElementById(elementId);
					var morphElementhost = document.getElementById(elementhostId);
					//
					Object.assign(morphElement.style, {
						"opacity": elementOpacity,
						"filter": elementBlur,
						"transform": elementTransform
					});
					Object.assign(morphElementhost.style, {
						"transform": elementhostTransform
					});
					elementCount++;
				});
				//
			}
		}]);

		return Kinetictext;
	}(_react.Component);

	Kinetictext.contextTypes = {}
	// empty

	//
	;
	exports.default = Kinetictext;
});